<template>
    <b-container>
        <b-row class="mt-2 mb-2">

            <b-col md="3">
                <b-form-input
                    v-model="search"
                    max="25"
                    type="search"
                    placeholder="Ara"
                    @input="updateSearch($event)"
                ></b-form-input>
            </b-col>

            <b-col md="4" offset-md="5">
                <div class="float-right">
                    Sayfa Başına: &nbsp;
                    <b-select size="sm"
                              v-model="perPage"
                              :options="availablePerPageOptions"
                              class="d-inline-block w-auto"/>
                </div>
            </b-col>

        </b-row>
        <div class="table-resposive">
            <b-table
                v-if="todos"
                id="todo-table"
                ref="todoTable"
                striped
                hover
                :fields="fields"
                fixed
                show-empty
                :items="getPageWithQuery"
                :current-page="currentPage"
                :per-page="perPage"
                :filter="search"
                :filter-debounce="searchDebounce"
            >

                <template v-slot:cell(is_finish)="data">
                    <b-form-checkbox
                        v-model="data.item.is_finish != null"
                        @change="setState($event, data.item)"
                        switch
                    >
                    </b-form-checkbox>
                </template>

                <template v-slot:cell(priority)="data">
                    <template v-if="key = priority(data.item.priority)">
                        <b-badge :variant="key.variant">{{ key.text }}</b-badge>
                    </template>
                </template>

                <template v-slot:cell(created_at)="data">
                    <span>{{ data.item.created_at | date }}</span>
                </template>

                <template v-slot:empty="data">
                    <span class="text-muted text-center"> Tabloda Gösterilecek Veri Bulunamadı</span>
                </template>

                <template v-slot:table-busy>
                    <div class="text-center text-danger my-2">
                        <b-spinner class="align-middle"></b-spinner>
                        <strong>Yükleniyor...</strong>
                    </div>
                </template>

                <template v-slot:cell(options)="data">
                    <b-button-group size="sm">
                        <b-button variant="primary" @click="deleteConfirm(data.item)">
                            <b-icon icon="trash"></b-icon>
                        </b-button>
                        <b-button :disabled="data.item.is_finish != null" variant="primary" @click="updateModal(data.item)">
                            <b-icon icon="pencil-square"></b-icon>
                        </b-button>
                    </b-button-group>
                </template>

            </b-table>
            <div class="row">
                <div class="col-sm text-sm-left text-center mb-3 mb-sm-0">
                    <span class="text-muted" v-if="todos.meta">{{ currentPage }} / {{totalPages }} Sayfa</span>
                </div>
                <div class="col-sm">
                    <b-pagination class="justify-content-center justify-content-sm-end mb-2"
                                  v-if="todos.meta"
                                  v-model="currentPage"
                                  :total-rows="totalItems"
                                  :per-page="perPage"
                                  size="sm"/>
                </div>
            </div>
        </div>
    </b-container>
</template>

<script>
import {mapActions, mapGetters} from "vuex";

export default {
    name: "List",
    computed: {
        ...mapGetters('todo', {todos: 'todos'}),

        totalItems() {
            return this.todos.meta.total
        },

        totalPages() {
            let totalPage = Math.ceil(this.totalItems / this.perPage)
            return totalPage === 0 ? 1 : totalPage
        }
    },
    data() {
        return {
            fields: [
                {key: 'is_finish', sortable: false, label: 'Durum'},
                {key: 'content', sortable: false, label: 'Başlık'},
                {key: 'priority', sortable: false, label: 'Öncelik'},
                {key: 'created_at', sortable: true, label: 'Oluşturulma Tarihi'},
                {key: 'options', label: 'Seçenekler', tdClass: 'text-center'}
            ],
            availablePerPageOptions: [10, 25],
            currentPage: 1,
            perPage: 10,
            orderBy: 'created_at',
            sortedBy: 'desc',
            search: '',
            selectedTodo: null,
            searchDebounce: 500,
        }
    },
    methods: {
        ...mapActions('todo', [
            'getTodos',
            'deleteTodo',
            'updateTodo'
        ]),
        prepareQueryParams() {
            const sortQuery = (this.orderBy !== null) ? `&orderBy=${this.orderBy}&sortedBy=${this.sortedBy}` : ''
            const searchQuery = (this.search !== '') ? '&search=' + this.search : ''

            return `paginate=${this.perPage}&page=${this.currentPage}${sortQuery}${searchQuery}`
        },

        /**
         * url parameters are added here
         * @param currentPage
         * @param perPage
         * @param orderBy
         * @param sortDesc
         * @returns {Promise<*>}
         */
        async getPageWithQuery({currentPage = 1, perPage = 10, orderBy = 'created_at', sortDesc = true}) {
            this.currentPage = currentPage
            this.perPage = perPage
            this.orderBy = orderBy
            this.sortedBy = !sortDesc ? 'desc' : 'asc'
            await this.getTodos({query: this.prepareQueryParams()})

            return this.todos.data
        },
        deleteConfirm(item) {
            this.$confirm(
                {
                    title: 'Silme işlemi onayı',
                    message: `Silme işlemine devam etmek istediğinize emin misiniz?`,
                    button: {
                        no: 'Hayır',
                        yes: 'Evet'
                    },
                    callback: confirm => {
                        if (confirm) {
                            this.deleteTodo(item.id)
                            this.$refs.todoTable.refresh()
                        }
                    }
                }
            )
        },
        updateModal(todo) {
            this.$emit('updateModal', todo)
        },
        updateSearch(value) {
            this.search = value
            this.currentPage = 1
        },
        async setState($event, todo) {
            await this.updateTodo({
                id: todo.id,
                payload: {
                    is_finish: $event,
                }
            })
        },
        /**
         * Calculates priority value, returns variant and text
         * @param value
         * @returns {{variant: string, text: string}}
         */
        priority: (value) => {
            let variant = ''
            let text = ''

            switch (true) {
                case value === 'low':
                    variant = 'success'
                    text = 'Düşük'
                    break
                case value === 'normal':
                    variant = 'primary'
                    text = 'Normal'
                    break
                case  value === 'high':
                    variant = 'danger'
                    text = 'Yüksek'
                    break
            }

            return {variant, text}
        }
    }
}
</script>

